//+------------------------------------------------------------------+
//|                                                      AvLife2.mq4 |

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed  
#property indicator_width1  2

extern int period=6;
double Buffer.Avlife2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(2);   
   SetIndexBuffer(0,Buffer.Avlife2);
   return(0);
}
int deinit() { return(0); }
int start()
  {
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //
      
	for (int i=limit; i>=0; i--)
   {
      Buffer.Avlife2[i] = 0; for (int k=0; k<period; k++) Buffer.Avlife2[i] += Close[i+k]; Buffer.Avlife2[i] /= period;
      if (i>(Bars-period)) continue;

      //
      //
      //
      //
      //
            
      double DIF                   = MathAbs(High[i]-Low[i])/(period*1.0);
      double DIF1                  = MathAbs(Close[i]-Close[i+1]);
      double medium.price          = (High[i]  +Low[i  ])/2.0;
      double medium.price.previous = (High[i+1]+Low[i+1])/2.0;

      if(medium.price>=Buffer.Avlife2[i+1]) 
      {
         if(medium.price<medium.price.previous)
 	           Buffer.Avlife2[i] = (Buffer.Avlife2[i+1]*(period-1.0)+(medium.price+DIF1))/(period*1.0);
         else Buffer.Avlife2[i] =  Buffer.Avlife2[i+1]-DIF;
      }
      if(medium.price<Buffer.Avlife2[i+1]) 
	   {
         if(medium.price>medium.price.previous)
 	           Buffer.Avlife2[i] = (Buffer.Avlife2[i+1]*(period-1.0)+(medium.price-DIF1))/(period*1.0);
         else Buffer.Avlife2[i] =  Buffer.Avlife2[i+1]+DIF;
      }
   }
   return(0);
}